<template>
	<div class="menu">
		<div class="submenu-title">OPTIONS</div>
		<component
			v-for="item in items"
			v-on:change="onChange"
			v-on:click="onItemClicked"
			v-on:hover="setSelected"
			:id="item.id"
			:is="item.type"
			:key="item.id"
			:options="item.options"
			:ref="item.ref"
			:selected="item.id === selected"
			:value="item.value"
		>{{ item.text }}</component>
	</div>
</template>

<script>
// Components
import BooleanItem from "../components/BooleanItem.vue"
import DropdownItem from "../components/DropdownItem.vue"
import InputItem from "../components/InputItem.vue"
import SliderItem from "../components/SliderItem.vue"
import StandardItem from "../components/StandardItem.vue"

// Constants
import { FLOOR_OPTIONS } from "../../constants/tower.js"
import { SUPPORTED_LANGUAGES } from "../../managers/LanguageManager.js"

export default {
	components: { BooleanItem, DropdownItem, InputItem, SliderItem, StandardItem },
	created () {
		UI.on("CHANGE_LANGUAGE", () => {
			this.onLanguageChange()
		})
	},
	data () {
		return {
			items: this.generateItems(),
			mounted: false,
			selected: 0
		}
	},
	destroyed () {
		this.mounted = false
	},
	methods: {
		beforeDestroy () {
			UI.off("PRESS_BACK", this.onBack)
			UI.off("PRESS_DOWN", this.pressDown)
			UI.off("PRESS_ENTER", this.pressEnter)
			UI.off("PRESS_LEFT", this.pressLeft)
			UI.off("PRESS_RIGHT", this.pressRight)
			UI.off("PRESS_UP", this.pressUp)
		},
		generateItems: function () {
			let items = [{
				id: 0,
				ref: "r0",
				text: "Name",
				type: "input-item",
				value: Settings.get("NAME") || ""
			}, {
				id: 1,
				options: SUPPORTED_LANGUAGES.map((lang) => {
					return Language.getIn("LANGUAGE_NAME", lang)
				}),
				ref: "r1",
				text: "Language",
				type: "dropdown-item",
				value: Language.get("LANGUAGE_NAME")
			}, {
				id: 2,
				ref: "r2",
				text: "BGM Volume",
				type: "slider-item",
				value: Settings.get("BGM_VOLUME")
			}, {
				id: 3,
				ref: "r3",
				text: "SFX Volume",
				type: "slider-item",
				value: Settings.get("SFX_VOLUME")
			}]

			if (!IS_XBOX) {
				items.push({
					id: 4,
					ref: "r4",
					text: "Fullscreen",
					type: "boolean-item",
					value: Settings.get("FULLSCREEN") || false
				})
			}

			return items
		},
		getSelected: function () {
			return this.$refs[this.items[this.selected].ref][0]
		},
		onBack: function () {
			const item = this.getSelected()

			if (item.focused) {
				item.blur()
			} else {
				UI.emit("GO_BACK")
			}
		},
		onChange: function (id, value) {
			switch (id) {
				case 0:
					Settings.set("NAME", value)
					break
				case 1:
					Settings.set("LANGUAGE", SUPPORTED_LANGUAGES[value])
					break
				case 2:
					Settings.set("BGM_VOLUME", +value)
					break
				case 3:
					Settings.set("SFX_VOLUME", +value)
					break
			}
			this.items = this.generateItems()
		},
		onClick: function (id) {
			UI.emit("PLAY_CLICK_SOUND")
			const item = this.$refs[this.items[id].ref][0]
			if (!item.focused) {
				item.onClick()
			} else {
				item.$emit("PRESS_ENTER")
			}
		},
		onItemClicked: function (id) {
			UI.emit("PLAY_CLICK_SOUND")
			UI.emit("SELECT_OPTIONS_MENU", id)
			this.items = this.generateItems()
		},
		onLanguageChange: function () {
			this.items[0].text = Language.get("LANGUAGE")
			// this.items[1].text = Language.get("LOCAL")
			this.items[1].text = Language.get("LANGUAGE_NAME")
			// this.items[3].text = Language.get("QUIT")
		},
		pressDown: function () {
			const item = this.getSelected()

			if (item.focused) {
				item.$emit("PRESS_DOWN")
			} else {
				this.setSelected(Math.min(this.items.length - 1, this.selected + 1))
			}
		},
		pressEnter: function () {
			this.onClick(this.selected)
		},
		pressLeft: function () {
			this.getSelected().$emit("PRESS_LEFT")
		},
		pressRight: function () {
			this.getSelected().$emit("PRESS_RIGHT")
		},
		pressUp: function () {
			const item = this.getSelected()

			if (item.focused) {
				item.$emit("PRESS_UP")
			} else {
				this.setSelected(Math.max(0, this.selected - 1))
			}
		},
		setSelected: function (id) {
			if (this.selected !== id) {
				UI.emit("PLAY_HOVER_SOUND")
			}
			this.selected = id
		}
	},
	mounted () {
		this.mounted = true

		// Update the tower
		Tower.goToFloor(FLOOR_OPTIONS)

		// Events
		UI.on("PRESS_BACK", this.onBack)
		UI.on("PRESS_DOWN", this.pressDown)
		UI.on("PRESS_ENTER", this.pressEnter)
		UI.on("PRESS_LEFT", this.pressLeft)
		UI.on("PRESS_RIGHT", this.pressRight)
		UI.on("PRESS_UP", this.pressUp)
	},
	name: "options-menu"
}
</script>

<style lang="less" scoped>
@import "./styles/Menu.less";

.menu {
	width: 80em;
}
</style>